package afero2webdav

import (
	"context"
	"github.com/spf13/afero"
	"golang.org/x/net/webdav"
	"os"
)

var _ webdav.FileSystem = (*Afero2Webdav)(nil)

type Afero2Webdav struct {
	AferoFs afero.Fs
}

func NewAfero2Webdav(aferoFs afero.Fs) *Afero2Webdav {
	return &Afero2Webdav{
		AferoFs: aferoFs,
	}
}

func (a Afero2Webdav) Mkdir(_ context.Context, name string, perm os.FileMode) error {
	return a.AferoFs.Mkdir(name, perm)
}

func (a Afero2Webdav) OpenFile(_ context.Context, name string, flag int, perm os.FileMode) (webdav.File, error) {
	return a.AferoFs.OpenFile(name, flag, perm)
}

func (a Afero2Webdav) RemoveAll(_ context.Context, name string) error {
	return a.AferoFs.RemoveAll(name)
}

func (a Afero2Webdav) Rename(_ context.Context, oldName, newName string) error {
	return a.AferoFs.Rename(oldName, newName)
}

func (a Afero2Webdav) Stat(_ context.Context, name string) (os.FileInfo, error) {
	return a.AferoFs.Stat(name)
}
